//+------------------------------------------------------------------+
//|                              Meta COT: WILLCO Movement Index.mq4 |
//|   Copyright  2010, C-4 (Vasiliy Sokolov, Russia, St.-Petersburg,|
//|                                2009, 2010), All Rights Reserved. |
//|                                                   vs-box@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, C-4, All Rights Reserved."
#property link      "vs-box@mail.ru"

#property indicator_separate_window
#property  indicator_buffers 3

#property  indicator_color1  Blue
#property  indicator_color2  Red
#property  indicator_color3  Silver

extern int  period=52;
extern int movement_index=6;
extern bool Show_iNoncomm=false;
extern bool Show_iOperators=true;
extern bool Show_iNonrep=false;
extern bool revers_mode=false;

double i_movement_noncomm[];
double i_movement_operators[];
double i_movement_nonrep[];
double i_movement_oi[];

#include <cotlib.mq4>

int init()
{
   if(init_data()==false)error=true;
   if(error==false)load_data();
   if(error==false)count_data();
   SetParam();
}

int start()
{
   if(error==true)return(-1);
   if(DrawData==true)build_data();
}

void SetParam()
{
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   IndicatorDigits(2);
   SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexEmptyValue(1,EMPTY_VALUE);
   SetIndexEmptyValue(2,EMPTY_VALUE);
   SetLevelValue(0,-40.0);
   SetLevelValue(1,0.0);
   SetLevelValue(2,40.0);
   SetLevelStyle(0,0,Black);
   if(load_cot_file==true)IndicatorShortName(StringConcatenate("Meta COT WILLCO Movement Index (",period,";",movement_index,"): ",str_trim(cot_file)));
   else IndicatorShortName(StringConcatenate("Meta COT WILLCO Movement Index (",period,";",movement_index,"): ",name));
   if(Show_iNoncomm==true){
      SetIndexBuffer(0,i_movement_noncomm);
      SetIndexLabel(0,"WILLCO Movement Index: Noncommercial Traders");
   }
   if(Show_iOperators==true){
      SetIndexBuffer(1,i_movement_operators);
      SetIndexLabel(1,"WILLCO Movement Index: Operators Traders");
   } 
   if(Show_iNonrep==true){
      SetIndexBuffer(2,i_movement_nonrep);
      SetIndexLabel(2,"WILLC Movement Index: Nonrep Traders");
   }
}

void build_data()
{
   int end_data=get_lastdata();
   for(int i=0;i<end_data;i++){
      if(Show_iNoncomm&&revers_mode==false)i_movement_noncomm[i]=get_data(WILLCO_NONCOMM, i)-get_data(MOVEMENT_OI,i+movement_index);
      if(Show_iNoncomm&&revers_mode==true)i_movement_noncomm[i]=(-1)*(get_data(WILLCO_NONCOMM, i)-get_data(MOVEMENT_OI,i+movement_index));
      
      if(Show_iOperators&&revers_mode==false)i_movement_operators[i]=get_data(WILLCO_OPERATORS, i)-get_data(WILLCO_OPERATORS,i+movement_index);
      if(Show_iOperators&&revers_mode==true)i_movement_operators[i]=(-1)*(get_data(WILLCO_OPERATORS, i)-get_data(WILLCO_OPERATORS,i+movement_index));
      
      if(Show_iNonrep&&revers_mode==false)i_movement_nonrep[i]=get_data(WILLCO_NONREP,i)-get_data(WILLCO_NONREP,i+movement_index);
      if(Show_iNonrep&&revers_mode==true)i_movement_nonrep[i]=(-1)*(get_data(WILLCO_NONREP,i)-get_data(WILLCO_NONREP,i+movement_index));
   }
   DrawData=false;
}